# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.chunk_header import ChunkHeader
from twnet_parser.packer import SANITIZE_CC, pack_int, pack_str

class MsgDeClientEnter(PrettyPrint):
    def __init__(
            self,
            name: str = 'default',
            client_id: int = 0,
            team: int = 0
    ) -> None:
        self.message_name = 'de_client_enter'
        self.system_message = False
        self.header: ChunkHeader

        self.name: str = name
        self.client_id: int = client_id
        self.team: int = team

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.name = unpacker.get_str(SANITIZE_CC)
        self.client_id = unpacker.get_int()
        self.team = unpacker.get_int() # TODO: this is a enum
        return True

    def pack(self) -> bytes:
        return pack_str(self.name) + \
            pack_int(self.client_id) + \
            pack_int(self.team)